/**
 * OW2 Util
 * Copyright (C) 2008 Bull S.A.S.
 * Contact: easybeans@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 *
 * --------------------------------------------------------------------------
 * $Id: IRemoveMethod.java 4389 2008-12-15 13:48:57Z alitokmen $
 * --------------------------------------------------------------------------
 */

package org.ow2.util.ee.metadata.ejbjar.api.xml.struct;

import java.io.Serializable;

import org.ow2.util.ee.metadata.common.api.xml.struct.IMethodDD;

/**
 * Interface for element remove-method.
 * @author Florent Benoit
 */
public interface IRemoveMethod extends Serializable {

    /**
     * Name of this element.
     */
    String NAME = "remove-method";

    /**
     * Sets the method of the bean which needs to be marked.
     * @param method the method to use
     */
    void setMethod(final IMethodDD method);

    /**
     * @return the method that will be used as a remove method
     */
    IMethodDD getMethod();

    /**
     * If there is an exception, the bean should be kept or not.
     * @param retainIfException true to keep, or false to remove
     */
    void setRetainIfException(final boolean retainIfException);

    /**
     * @return the flag to know if when there is an exception, the bean should be kept or not.
     * It returns null if it was not set.
     */
    Boolean getRetainIfException();

}
